/*
 * data.c
 */
#include "copyright.h"

#include "defs.h"
#include "struct.h"
#include "data.h"
#include <sys/time.h>

struct player  *players;
struct player  *me;
struct torp    *torps;
struct plasmatorp *plasmatorps;
struct status  *status;
struct ship    *myship;
struct stats   *mystats;
struct planet  *planets;
struct phaser  *phasers;
struct message *messages;
struct mctl    *mctl;
struct team    *teams;
#ifdef VOTE
struct vote    *vote;
#endif

int             bypassed = 0;	/* is this user allowed to bypass the binary
				 * check? */
int             backTorpHeat = 0;	/* dank -- When true, firing torps
					 * backwards REALLY heats weapons... */
int             announceTop10;	/* Whether or not to announce the arrival of
				 * a top 10 player */
int             notmodebomb;	/* When is bombing allowed? */
char            nombreDios[32];	/* The name of God (defined in main) */

int             remap[9] = {0, 1, 2, -1, 3, -1, -1, -1, 4};
int             messpend;
int             lastcount;
int             mdisplayed;
int             redrawall;
int             selfdest;
int             udcounter;
int             lastm;
int             delay;		/* delay for decaring war */
int             rdelay;		/* delay for refitting */
int             mapmode = 1;
int             namemode = 1;
int             showStats;
int             showShields;
int             warncount = 0;
int             warntimer = -1;
int             infomapped = 0;
int             mustexit = 0;
int             messtime = MESSTIME;
int             keeppeace = 0;
int             showlocal = 2;
int             showgalactic = 2;
char           *shipnos = "0123456789abcdefghijklmnopqrstuvwxyz";
int             sock = -1;
int             xtrekPort = 2592 /* 27320 */ ;
int             shipPick;
int             teamPick;
int             repCount = 0;
char            namePick[16];
char            passPick[16];
int             inputMask = -1;
int             nextSocket;
char           *host;
int             noressurect = 0;
int             userVersion = 0;
int             timerDelay = 200000;	/* delay between sending stuff to
					 * client */
#ifdef RSA
char            testdata[KEY_SIZE];
int             RSA_Client = 0;
char 		RSA_client_type[256];
#else
char            testdata[16];
#endif
int             testtime = -1;
char           *serverName = "calvin.usc.edu";
int             tournplayers = 5;
int             shipsallowed[NUM_TYPES];
int             weaponsallowed[WP_MAX];
int             plkills = 2;
int             sbrank = 3;
int             startplanets[MAXPLANETS];
int             binconfirm = 1;
int             chaos = 0;
int             shipwrap = 0;	/* jfy -- make ships bounce off of the walls */
int             ksuchaos = 0;	/* jfy -- KSU chaos stuff */
int             lastexplode = 0;/* jfy -- last torp explodes */
int             expltorps = 0;	/* jfy -- exploding torps */
int             sbwarp = 2;	/* jfy -- default warp of sb's in ksuchaos
				 * mode */
int             straightorps = 0;	/* jfy -- straight player torps? */
int             hourratio = 1;	/* Fix thing to make guests advance fast */
int             hiddenenemy = 1;
float           maxload = 0.7;
int             vectortorps = 0;
int             allwar = 0;

#ifdef SNAKEPATROL
int             snakepatrol = 0;
#endif

#ifdef MINES
int             mines = 0;	/* starbase mines */
int             minedet = SHIPDAMDIST;	/* detonate range */
int             minerot = 5;	/* rotation freq in cycles (5 == .5 seconds) */
int             minepow = 4;	/* power times ship s_torpdamage (must be >1) */
#endif

char            sysdef_file[MAXFNLEN];	/* note size */
char            sysdef_comment[80];	/* string descriptor */
int             timecheck = 0;	/* boolean, indicates time change of sysdef */
int             totimecheck = 0;/* so the daemon doesn't call time() every
				 * upd */
int             timechecknew = 0;	/* when a new sysdef file should be
					 * read */

int             userUdpVersion = 0;
int             udpSock = -1;
int             commMode = 0;
int             udpAllowed = 1;

int             checkmessage = 0;
int             logall = 0;
int             loggod = 0;

int             cloakdelay = CLOAK_PHASES - 1;

int             gamedown = 0;

#ifdef BASEPRACTICE
int             basepractice = 0;
#endif

#ifdef ORGANIAN
int             organian = 0;
int             whoconq = -1;
#endif

double          oldmax = 0.0;

extern
double          Sin[], Cos[];	/* Initialized in sintab.c */

char            teamlet[] = {'I', 'F', 'R', 'X', 'K', 'X', 'X', 'X', 'O'};
char           *teamshort[9] = {"IND", "FED", "ROM", "X", "KLI", "X", "X", "X", "ORI"};
char            pseudo[PSEUDOSIZE];
char            login[PSEUDOSIZE];

char           *shiptypes[NUM_TYPES + 1] = {"SC", "DD", "CA", "BB", "AS", "SB",
"GA", "AT", "??"};

struct rank     ranks[NUMRANKS] = {
   {0.0, 0.0, 0.0, "Ensign"},
   {2.0, 1.0, 0.0, "Lieutenant"},
   {4.0, 2.0, 0.0, "Lt. Cmdr."},
   {8.0, 3.0, 0.0, "Commander"},
   {15.0, 4.0, 0.0, "Captain"},
   {20.0, 5.0, 0.0, "Flt. Capt."},
   {25.0, 6.0, 0.0, "Commodore"},
   {30.0, 7.0, 0.0, "Rear Adm."},
{40.0, 8.0, 0.0, "Admiral"}};

int             startTkills, startTlosses, startTarms, startTplanets, 
		startTticks, startSBkills, startSBlosses, startSBticks;
#ifdef BASEPRACTICE
double		startTdami, startTdamr;
#endif

#ifdef SB_DOCK
int             sb_dock = 0;
#endif

int             ping = 0;	/* to ping or not to ping, client's decision */
long            packets_sent = 0;	/* # all packets sent to client */
long            packets_received = 0;	/* # all packets received from client */
int             ping_ghostbust = 0;	/* ghostbust timer */

/* defaults variables */
int             ping_freq = 1;	/* ping freq. in seconds */
int             ping_iloss_interval = 10;	/* in values of ping_freq */
int             ping_allow_ghostbust = 0;	/* allow ghostbust detection
						 * from ping_ghostbust
						 * (cheating possible) */
int             ping_ghostbust_interval = 5;	/* in ping_freq, when to
						 * ghostbust if allowed */

#ifdef SB_TRANSWARP
int 		twarpMode=0;       /* isae - SB transwarp */
int 		twarpSpeed=60;     /* isae - Warp speed */
#endif

int		jmn_planets = 0;		/* jmn planet arrangement */

#ifdef SHORT_PACKETS
int 		send_short = 0;
#endif

char		*cl_version;	/* client version (if supported) */

#ifdef FEATURE
int		F_client_feature_packets = 0;
int		F_why_dead = 0;
int		F_self_8flags = 0;
int		F_self_8flags2 = 0;
int		F_cloak_maxwarp = 0;
int		F_motd_bitmaps = 0;
#endif

int promotion = 0;

#ifdef RCD
int num_distress;

/* the following copied out of BRM data.c */

int num_distress;

     /* the index into distmacro array should correspond 
   	with the correct dist_type */
struct  dmacro_list distmacro[] = {
	{ 'X', "no zero", "this should never get looked at" },
	{ 't', "taking", " %T%c->%O (%S) Carrying %a to %l%?%n>-1%{ @ %n%}\0"},
	{ 'o', "ogg", " %T%c->%O Help Ogg %p at %l\0" },
	{ 'b', "bomb", " %T%c->%O %?%n>4%{bomb %l @ %n%!bomb%}\0"},
	{ 'c', "space_control", " %T%c->%O Help Control at %L\0" },
	{ '1', "save_planet", " %T%c->%O Help at %l! %?%a>0%{ (have %a arm%?%a=1%{y%!ies%}) %} %s%% shld, %d%% dam, %f%% fuel\0" },
	{ '2', "base_ogg", " %T%c->%O Sync with --]> %g <[-- OGG ogg OGG base!!\0" },
	{ '3', "help1", " %T%c->%O Help me! %d%% dam, %s%% shd, %f%% fuel %a armies.\0" },
	{ '4', "help2", " %T%c->%O Help me! %d%% dam, %s%% shd, %f%% fuel %a armies.\0" },
	{ 'e', "escorting", " %T%c->%O ESCORTING %g (%d%%D %s%%S %f%%F)\0" },
	{ 'p', "ogging", " %T%c->%O Ogging %h\0" },
	{ 'm', "bombing", " %T%c->%O Bombing %l @ %n\0" },
	{ 'l', "controlling", " %T%c->%O Controlling at %l\0" },
	{ '5', "asw", " %T%c->%O Anti-bombing %p near %b.\0" } ,
	{ '6', "asbomb", " %T%c->%O DON'T BOMB %l. Let me bomb it (%S)\0" } ,
	{ '7', "doing1", " %T%c->%O (%i)%?%a>0%{ has %a arm%?%a=1%{y%!ies%}%} at lal.  %d%% dam, %s%% shd, %f%% fuel\0" } ,
	{ '8', "doing2", " %T%c->%O (%i)%?%a>0%{ has %a arm%?%a=1%{y%!ies%}%} at lal.  %d%% dam, %s%% shd, %f%% fuel\0" } ,
	{ 'f', "free_beer", " %T%c->%O %p is free beer\0" },
	{ 'n', "no_gas", " %T%c->%O %p @ %l has no gas\0" },
	{ 'h', "crippled", " %T%c->%O %p @ %l crippled\0" },
	{ '9', "pickup", " %T%c->%O %p++ @ %l\0" },
	{ '0', "pop", " %T%c->%O %l%?%n>-1%{ @ %n%}!\0"},
	{ 'F', "carrying", " %T%c->%O %?%S=SB%{Your Starbase is c%!C%}arrying %?%a>0%{%a%!NO%} arm%?%a=1%{y%!ies%}.\0" },
	{ '@', "other1", " %T%c->%O (%i)%?%a>0%{ has %a arm%?%a=1%{y%!ies%}%} at lal. (%d%%D, %s%%S, %f%%F)\0" },
	{ '#', "other2", " %T%c->%O (%i)%?%a>0%{ has %a arm%?%a=1%{y%!ies%}%} at lal. (%d%%D, %s%%S, %f%%F)\0" },
	{ 'E', "help", " %T%c->%O Help(%S)! %s%% shd, %d%% dmg, %f%% fuel,%?%S=SB%{ %w%% wtmp,%!%}%E%{ ETEMP!%}%W%{ WTEMP!%} %a armies!\0" },
	{ '\0', '\0', '\0'},
};


#endif /* RCD */

#ifdef USE_EROBOT
int	erobot = 0;
#endif
