
/*
 * erobot.c.c
 */
#include "copyright.h"

#include <stdio.h>
#include <ctype.h>
#include <sys/types.h>
#include <signal.h>
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"
#ifndef _NO_DEPEND
#   include "ntserv_protos.h"
#endif

#define SECRET_PORT		3414	/* experimental */
#define RESCUE_COM		".rescue_com"
#define PRACTICE_COM		".practice_com"

static 
char           *rnames[5] = {"Terminator", "M5", "Colossus", "Guardian", 
			     "HAL"};

/* linked with both daemonII.c (rescue()) and ntserv (practice_robo())
 */

void
rescue(planet_team, offender)

   int			planet_team;
   struct player	*offender;
{
   char			buf[BUFSIZ];
   int			ship = offender->p_ship.s_type;

   switch(ship){
      case SCOUT:
      case DESTROYER:
	 ship = 's';
	 break;
      case CRUISER:
      case BATTLESHIP:
      case ASSAULT:
      default:
	 ship = 'c';
	 break;
   }

   sprintf(buf, "%s -1 -c%c -T%c -t+ %d -p %d -X r1h0f -n %s -b -C %s 1> /dev/null 2>/dev/null &",
	EROBOT, 
	ship,
	tolower(teamlet[planet_team]),
	offender->p_no,
	SECRET_PORT,
	rnames[remap[planet_team]],
	RESCUE_COM);
   
   /*
   printf("%s\n", buf);
   fflush(stdout);
   */

   if (fork() == 0) {
      (void) signal(SIGALRM, SIG_DFL);
      (void) close(0);
      (void) close(1);
      (void) close(2);
      execl("/bin/sh", "sh", "-c", buf, 0);
      perror("erobot'execl");
      _exit(1);
   }
}


void
practice_erobo(p)
   
   struct player	*p;
{
   char			buf[BUFSIZ];
   int			team, ship;

   switch(p->p_team){
      case FED:
	 team = ORI;
	 break;
      case ROM:
	 team = FED;
	 break;
      case KLI:
	 team = ROM;
	 break;
      case ORI:
	 team = KLI;
	 break;
      default:
	 team = FED;
   }
   ship = random() % 5;
   switch(ship){
      case 0:
	 ship = 's';
	 break;
      case 1:
	 ship = 'd';
	 break;
      case 2:
	 ship = 'c';
	 break;
      case 3:
	 ship = 'b';
	 break;
      case 4:
	 ship = 'a';
	 break;
      default:
	 ship = 'c';
   }

   sprintf(buf, 
	"%s -c%c -T%c -t %d -p %d -X r1h1f -n Hoser -b -C %s -1 -O 1> /dev/null 2>/dev/null &",
	EROBOT, 
	ship,
	tolower(teamlet[team]),
	p->p_no,
	SECRET_PORT,
	PRACTICE_COM);

   /*
   printf("%s\n", buf);
   fflush(stdout);
   */

   if (fork() == 0) {
      (void) signal(SIGALRM, SIG_DFL);
      (void) close(0);
      (void) close(1);
      (void) close(2);
      execl("/bin/sh", "sh", "-c", buf, 0);
      perror("erobot'execl");
      _exit(1);
   }
}
