/*
 * startdaemon.c
 */
#include "copyright.h"

#include <stdio.h>
#include <sys/types.h>
#include <signal.h>
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"
#ifndef _NO_DEPEND
#   include "ntserv_protos.h"
#endif

#ifdef USE_SYS_PROTOS
#if defined(__STDC__) || defined(__cplusplus)
#define P_(s) s
#else
#define P_(s) ()
#endif

extern pid_t                  fork P_((void));
extern int                    execl P_((const char *, const char *, ...));
extern void                   perror P_((const char *));
extern int                    fprintf P_((FILE *, const char *, ...));
extern int                    fflush P_((FILE *));
extern int                    close P_((int));

#undef P_
#endif

void
startdaemon()
{
   int             i;

   i = fork();
   if (i == 0) {
      execl(DAEMON, "daemon", 0);
      perror(DAEMON);
      fprintf(stderr, "Couldn't start daemon!!!\n");
      fflush(stderr);
      _exit(1);
   }
}

int
time_passed(range, last)

   int  range, *last;
{
   int  now = time(NULL);
   int  ret;
   ret = now - *last >= range;
   *last = now;
   return ret;
}

void
practice_robo(p)
   
   struct player	*p;
{
   char           *arg1 = NULL;
   register int    i;
   register struct player *j;
#ifdef PRACSTARBASE
   int             sb = (p->p_ship.s_type == STARBASE);
#endif

   static int      last_time;

   if(!time_passed(2, &last_time))
      return;

   for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++) {
      if (j->p_status != PALIVE)
	 continue;
      if (j == p)
	 continue;
      warning(1, 
	 "Can't send in practice robot with other players in the game.", -1);
      return;
   }

#ifdef USE_EROBOT	/* in erobot.c */
   practice_erobo(p);
#else

   if (fork() == 0) {
      (void) signal(SIGALRM, SIG_DFL);
      (void) close(0);
      (void) close(1);
      (void) close(2);
      switch (p->p_team) {
      case FED:
	 arg1 = "-Tf";
	 break;
      case ROM:
	 arg1 = "-Tr";
	 break;
      case KLI:
	 arg1 = "-Tk";
	 break;
      case ORI:
	 arg1 = "-To";
	 break;
      }
#ifdef PRACSTARBASE
      if (sb)
	 execl(ROBOT, "robot", arg1, "-p", "-f", "-h", "-B", 0);
      else
#endif
	 execl(ROBOT, "robot", arg1, "-p", "-f", "-h", 0);
      /* If we get here, we are hosed anyway */
      _exit(1);
   }
#endif
}
