#include <stdio.h>

#include "defs.h"
#include "struct.h"

#if __STDC__ || defined(__cplusplus)
#define P_(s) s
#else
#define P_(s) ()
#endif

/* edit_global.c */
int get_int P_((char *s, int old));
double get_double P_((char *s, double old));

#undef P_

/*
   int             active;
   unsigned int    wait, count;
   unsigned int    number, request, answer;
   unsigned char   tourn;

   unsigned int    armsbomb, planets, kills, losses, time;
   double	   timeprod;
   int             gameup;
#ifdef BASEPRACTICE
   double          dami, damr;
#endif
*/

void
main(argc, argv)

   int	argc;
   char	**argv;
{
   FILE			*fi, *fo;
   struct status	old, new;

   if(argc != 2) {
      fprintf(stderr, "%s <global>\n", argv[0]);
      exit(0);
   }
   fi = fopen(argv[1], "r");
   if(!fread(&old, sizeof(old), 1, fi)){
      perror(argv[1]);
      exit(1);
   }

   new.active = get_int("active", old.active);
   new.wait = get_int("wait", old.wait);
   new.count = get_int("count", old.count);
   new.number = get_int("number", old.number);
   new.request = get_int("request", old.request);
   new.answer = get_int("answer", old.answer);
   new.tourn = get_int("tourn", old.tourn);
   new.armsbomb = get_int("armsbomb", old.armsbomb);
   if(new.armsbomb < 10)
      new.armsbomb = 10;
   new.planets = get_int("planets", old.planets);
   if(new.planets < 10)
      new.planets = 10;
   new.kills = get_int("kills", old.kills);
   if(new.kills < 10)
      new.kills = 10;
   new.losses = get_int("losses", old.losses);
   if(new.losses < 10)
      new.losses = 10;
   new.time = get_int("time", old.time);
   if(new.time < 10)
      new.time = 10;
   
   new.timeprod = get_double("timeprod", old.timeprod);

   new.gameup = get_int("gameup", old.gameup);
#ifdef BASEPRACTICE
   new.dami = get_double("dami", old.dami);
   new.damr = get_double("damr", old.damr);
#endif

   fo = fopen("NEW.global", "w");
   if(!fo) { perror("NEW.global"); exit(1); }
   if(!fwrite(&new, sizeof(new), 1, fo)){
      perror("NEW.global");
      exit(1);
   }
   printf("output is NEW.global\n");
}

int
get_int(s, old)

   char	*s;
   int	old;
{
   char			buf[80];
   int	new;
   printf("%s (%d)? ", s, old); fflush(stdout);
   gets(buf);
   if(!buf[0]) return old;
   sscanf(buf, "%d", &new);
   return new;
}

double
get_double(s, old)

   char	*s;
   double	old;
{
   char			buf[80];
   double	new;
   printf("%s (%f)? ", s, old); fflush(stdout);
   gets(buf);
   if(!buf[0]) return old;
   sscanf(buf, "%lf", &new);
   return new;
}
