#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <errno.h>
#include <string.h>
#include <strings.h>
#include <ctype.h>
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"

#if __STDC__ || defined(__cplusplus)
#define P_(s) s
#else
#define P_(s) ()
#endif

void main P_((int argc, char **argv));
void show P_((struct statentry *stat));
void saveplayer P_((int plfd, int pos, struct statentry *player));

#ifdef USE_SYS_PROTOS
extern void                   perror P_((const char *));
extern int                    fprintf P_((FILE *, const char *, ...));
extern int                    printf P_((const char *, ...));
extern int                    fflush P_((FILE *));
extern int                    sscanf P_((const char *, const char *, ...));
#endif

#undef P_

int		num_db_entries;
char		**db_entries;

void
main(argc, argv)
   
   int	argc;
   char	**argv;
{
   char			*db = PLAYERFILE;
   int			plfd;
   int			pos;
   struct statentry	player;
   int			found=0;
   char			buf[80], buf2[80];

   if(argc > 1){
      if(strcmp(argv[1], "-d")==0){
	 db = PLAYERFILE_DB;
	 argc--;
	 argv++;
      }
   }

   if(argc == 1){
      fprintf(stderr, "usage: %s <player name>\n", argv[0]);
      exit(0);
   }

   plfd= open(db, O_RDWR, 0644);
   if(plfd < 0){
      perror(db);
      exit(1);
   }

   pos=0;
   while(read(plfd, (char *) &player, sizeof(struct statentry)) ==
         sizeof(struct statentry)){
      if(strcmp(player.name, argv[1])==0){
	 found = 1;
	 break;
      }
      pos++;
   }
   if(!found){
      fprintf(stderr, "%s not found.\n", argv[1]);
      exit(1);
   }

   printf("name (%s): ", player.name); fflush(stdout);
   gets(buf);
   if(buf[0]){
      strncpy(player.name, buf, 16);
      player.name[15]=0;
   }
   printf("password (%s): ", player.password); fflush(stdout);
   gets(buf);
   if(buf[0]){
      sscanf(buf, "%s", buf2);
      strncpy(player.password, buf2, 16);
      player.password[15]=0;
   }
   printf("st_maxkills (%g): ", player.stats.st_maxkills); fflush(stdout);
   gets(buf);
   if(buf[0]){
      sscanf(buf, "%lf", &player.stats.st_maxkills);
   }
   printf("st_tkills (%d): ", player.stats.st_tkills); fflush(stdout);
   gets(buf);
   if(buf[0]){
      sscanf(buf, "%d", &player.stats.st_tkills);
   }
   printf("st_tlosses (%d): ", player.stats.st_tlosses); fflush(stdout);
   gets(buf);
   if(buf[0]){
      sscanf(buf, "%d", &player.stats.st_tlosses);
   }
   printf("st_tarmsbomb (%d): ", player.stats.st_tarmsbomb); fflush(stdout);
   gets(buf);
   if(buf[0]){
      sscanf(buf, "%d", &player.stats.st_tarmsbomb);
   }
   printf("st_tplanets (%d): ", player.stats.st_tplanets); fflush(stdout);
   gets(buf);
   if(buf[0]){
      sscanf(buf, "%d", &player.stats.st_tplanets);
   }
   printf("st_tticks (%d): ", player.stats.st_tticks); fflush(stdout);
   gets(buf);
   if(buf[0]){
      sscanf(buf, "%d", &player.stats.st_tticks);
   }
   printf("st_sbkills (%d): ", player.stats.st_sbkills); fflush(stdout);
   gets(buf);
   if(buf[0]){
      sscanf(buf, "%d", &player.stats.st_sbkills);
   }
   printf("st_sblosses (%d): ", player.stats.st_sblosses); fflush(stdout);
   gets(buf);
   if(buf[0]){
      sscanf(buf, "%d", &player.stats.st_sblosses);
   }
   printf("st_sbticks (%d): ", player.stats.st_sbticks); fflush(stdout);
   gets(buf);
   if(buf[0]){
      sscanf(buf, "%d", &player.stats.st_sbticks);
   }
   printf("st_sbmaxkills (%g): ", player.stats.st_sbmaxkills); fflush(stdout);
   gets(buf);
   if(buf[0]){
      sscanf(buf, "%lf", &player.stats.st_sbmaxkills);
   }
   printf("st_rank (%d): ", player.stats.st_rank); fflush(stdout);
   gets(buf);
   if(buf[0]){
      sscanf(buf, "%d", &player.stats.st_rank);
   }
   show(&player);
   printf("Save (yes/no)? "); fflush(stdout);
   gets(buf);
   if(strcmp(buf, "yes")==0){
      saveplayer(plfd, pos, &player);
      printf("Saved.\n");
   }
   else{
      printf("Not saved.\n");
   }
   close(plfd);
}

void
show(sstat)

   struct statentry	*sstat;
{
   printf("\n");
   printf("%-30s\"%s\"\n", "name:", sstat->name);
   printf("%-30s\"%s\"\n", "password:", sstat->password);
   printf("%-30s%f\n", "st_maxkills:", sstat->stats.st_maxkills);
   printf("%-30s%d\n", "st_tkills:", sstat->stats.st_tkills);
   printf("%-30s%d\n", "st_tlosses:", sstat->stats.st_tlosses);
   printf("%-30s%d\n", "st_tarmsbomb:", sstat->stats.st_tarmsbomb);
   printf("%-30s%d\n", "st_tplanets:", sstat->stats.st_tplanets);
   printf("%-30s%d\n", "st_tticks:", sstat->stats.st_tticks);
   printf("%-30s%d\n", "st_sbkills:", sstat->stats.st_sbkills);
   printf("%-30s%d\n", "st_sblosses:", sstat->stats.st_sblosses);
   printf("%-30s%d\n", "st_sbticks:", sstat->stats.st_sbticks);
   printf("%-30s%f\n", "st_sbmaxkills:", sstat->stats.st_sbmaxkills);
   printf("%-30s%d\n", "st_rank:", sstat->stats.st_rank);
#ifdef BASEPRACTICE
   printf("%-30s%f\n", "st_dami:", sstat->stats.st_dami);
   printf("%-30s%f\n", "st_damr:", sstat->stats.st_damr);
#endif
}


void
saveplayer(plfd, pos, player)

   int			plfd;
   int			pos;
   struct statentry	*player;
{
   if(pos > -1){
      /* seek from start of file */
      if(lseek(plfd, pos * sizeof(struct statentry), SEEK_SET) < 0){
	 perror("lseek");
	 exit(1);
      }
   }
   else{
      /* append */
      if(lseek(plfd, 0, SEEK_END) < 0){
         perror("lseek");
         exit(1);
      }
   }

   if(write(plfd, (char *) player, sizeof(struct statentry)) < 0){
      perror("write");
      exit(1);
   }
}
