#include <stdio.h>
#include <time.h>

#define MAX_PLAYER	20
static struct slot {
   char		name[64];
   char		login[64];
   char		host[64];
   struct tm	time;
   int		active;
   int		scum;
} slots[MAX_PLAYER];

main(argc, argv)
   
   int	argc;
   char	**argv;
{
   char		*lf;
   FILE		*fi;
   char		buf[256];
   char		name[64],
		login[64],
		host[64],
		date[64],
		test[64];
   struct tm	tmt;
   int		sv, pno;
   char		chr[3];
   int		my_armies, my_planets, team_planets;
   int		scum;

   if(argc == 1){
      lf = "logfile";
   }
   else{
      lf = argv[1];
   }
   fi = fopen(lf, "r");
   if(!fi){
      perror(lf);
      exit(1);
   }

   while(fgets(buf, 254, fi)){

      sv = sscanf(buf, "Joining: %[^(] (%[^@]@%[^)]) (%[^)]), %[^\n]",
	 name, login, host, chr, date);
      if(sv == 5){

	 (void)strptime(date, "%a %h %d %T %Y", &tmt);

	 /*
	 strftime(test, 64, "%a %h %d %T %Y", &tmt);
	 printf("\"%s\" (%s@%s) at %s\n", 
	    name, login, host, test);
	 */

	 pno = atoi(chr);
	 if(chr[0] >= 'a' && chr[0] <= 'j')
	    pno = chr[0] - 'a' + 10;
	 
	 scum = checkmult(login, host, name, &tmt, pno);

	 addslot(login, host, name, &tmt, pno, scum);
      }
      else {
	 sv = sscanf(buf, "Leaving: %[^,], %[^@]@%s (%[^)]), [%d, %d, %d] %[^\n]",
	    name, login, host, chr, &my_planets, &my_armies, &team_planets, 
	       date);
	 if(sv == 8){
	    
	    pno = atoi(&chr[1]);
	    if(chr[1] >= 'a' && chr[1] <= 'j')
	       pno = chr[1] - 'a' + 10;

	    (void)strptime(date, "%a %h %d %T %Y", &tmt);

	    deleteslot(login, host, name, &tmt, pno, my_armies, my_planets,
	       team_planets);
	 }
	 else {
	    /*
	    fprintf(stderr, "input error on line:\n");
	    fprintf(stderr, "%s", buf);
	    */
	 }
      }
   }
   fclose(fi);
   exit(0);
}

addslot(login, host, name, tm, pno, scum)

   char	*login,*host,*name;
   struct tm	*tm;
   int	pno;
   int	scum;
{
   if(pno < 0 || pno >= MAX_PLAYER){
      fprintf(stderr, "Bad pno value %d.\n", pno);
      exit(1);
   }
   strcpy(slots[pno].login, login);
   strcpy(slots[pno].host, host);
   strcpy(slots[pno].name, name);
   slots[pno].active = 1;
   slots[pno].scum = scum;
   bcopy(tm, &slots[pno].time, sizeof(struct tm));
   /*
   printf("adding %s to slot %d\n",
      login, pno);
   */
}

deleteslot(login, host, name, tm, pno, a, p, tp)

   char	*login,*host,*name;
   struct tm	*tm;
   int	pno;
   int	a,p,tp;
{
   struct slot	*sl;
   int		err;
   char		timev[64];
   
   if(pno < 0 || pno >= MAX_PLAYER){
      fprintf(stderr, "Bad pno value %d.\n", pno);
      exit(1);
   }

   sl = &slots[pno];

   if(!sl->active){
      /*
      strftime(timev, 64, "%a %h %d %T %Y", tm);
      fprintf(stderr, "slot %d already inactive: %s (%s@%s) %s\n",
	 pno, name, login, host, timev);
      */
      return;
   }

   err = 0;

   /*
   if(strcmp(sl->login, login) != 0)
      err ++;
   if(strcmp(sl->host, host) != 0)
      err++;
   if(strcmp(sl->name, name) != 0)
      err++;
   
   if(err){
      fprintf(stderr, "mismatched slot:\n");
      fprintf(stderr, "%s (%s@%s) left, %s (%s@%s) already there.\n",
	 name, login, host, sl->name, sl->login, sl->host);
   }
   */

   sl->active = 0;

   if(!err && sl->scum){
      strftime(timev, 64, "%D %l:%M%p", tm);
      printf("%s (%s@%s) left at %s with %d armies, %d planets out of %d\n",
	 name, login, host, timev, a, p, tp);
   }
}

checkmult(login, host, name, tm, pno)

   char	*login,*host,*name;
   struct tm	*tm;
   int	pno;
{
   register	i;
   struct slot	*sl;
   char		timev[64];
   int		count=0;

   for(i=0,sl=slots; i< MAX_PLAYER; i++,sl++){
      if(!sl->active)
	 continue;

      if(strcmp(login, sl->login) == 0){
	 count ++;
      }
   }
   if(count > 2){
      strftime(timev, 64, "%D %l:%M%p", tm);
      printf("%s (%s@%s) %d LOGGED IN at %s\n",
	 name, login, host,  count, timev);
      slots[pno].scum = 1; /* mark as possible scum */

      for(i=0,sl=slots; i< MAX_PLAYER; i++,sl++){
	 if(!sl->active || i == pno)
	    continue;
	 if(i == pno)
	    continue;
	 strftime(timev, 64, "%D %l:%M%p", sl->time);
	 printf("\t%c%s (%s@%s) %d at %s\n",
	    strcmp(login, sl->login) == 0?'+':' ',
	    sl->name, sl->login, sl->host,  i, timev);
      }
      return 1;
   }
   return 0;
}
